/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { Base, typeCast, Array_$type, Number_$type, markType } from "igniteui-react-core/ES5/type";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { VerticalAxisLabelPanel } from "./VerticalAxisLabelPanel";
import { MathUtil } from "igniteui-react-core/ES5/MathUtil";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { LinearCategorySnapper } from "./LinearCategorySnapper";
import { NumericXAxis } from "./NumericXAxis";
import { LabelPosition } from "./LabelPosition";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core/ES5/number";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
/**
 * @hidden
 */
var CategoryYAxis = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryYAxis, _super);
    function CategoryYAxis() {
        var _this = _super.call(this) || this;
        _this.kr = 0;
        _this.kt = 0;
        _this.kz = 1;
        _this.ky = 1;
        _this.jf = new List$1(Number_$type, 0);
        _this.ab = CategoryYAxis.$;
        return _this;
    }
    CategoryYAxis.prototype.a1 = function () {
        return new CategoryYAxisView(this);
    };
    CategoryYAxis.prototype.gm = function (a) {
        _super.prototype.gm.call(this, a);
        this.kq = a;
    };
    CategoryYAxis.prototype.get_ce = function () {
        return true;
    };
    CategoryYAxis.prototype.ds = function () {
        return this.iu.height;
    };
    CategoryYAxis.prototype.kn = function (a, b, c) {
        return this.ko(a, b, c, true);
    };
    CategoryYAxis.prototype.kp = function (a) {
        if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
            return a.asArray();
        }
        return null;
    };
    CategoryYAxis.prototype.gg = function (a, b, c, d, e) {
        var f;
        var g = e.e;
        var h = e.d;
        var i = e.c;
        var j = e.a;
        var k = !i.isEmpty;
        var l = this.categoryMode == 0 ? this.jr - 1 : this.jr;
        if (l < 0) {
            l = 0;
        }
        var m = i.top;
        var n = i.height;
        var o = g.top;
        var p = g.height;
        var q = h.top;
        var r = h.height;
        var s = 0;
        var t = 1;
        var u = this.kp(a);
        var v = false;
        if (u != null) {
            v = true;
        }
        var w;
        for (var x = 0; x < b.count; x++) {
            w = b.item(x);
            for (var y = c; y < d; y++) {
                if (v) {
                    f = u[y];
                }
                else {
                    f = a.item(y);
                }
                if (k) {
                    var z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (!j) {
                        z = 1 - z;
                    }
                    z = m + n * (z - s) / t;
                    var aa = (z - (o * r)) / p;
                    f[w] = aa;
                }
                else {
                    var ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (!j) {
                        ab = 1 - ab;
                    }
                    ab = q + r * (ab - o) / p;
                    f[w] = ab;
                }
            }
        }
    };
    Object.defineProperty(CategoryYAxis.prototype, "kw", {
        get: function () {
            return this.c(CategoryYAxis.k8);
        },
        set: function (a) {
            this.h(CategoryYAxis.k8, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryYAxis.prototype, "ks", {
        get: function () {
            return this.kr;
        },
        set: function (a) {
            if (this.ks != a) {
                var b = this.kr;
                this.kr = a;
                this.gu("ActualInterval", b, this.ks);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryYAxis.prototype.d4 = function () {
        return this.ks;
    };
    Object.defineProperty(CategoryYAxis.prototype, "kx", {
        get: function () {
            return this.c(CategoryYAxis.k9);
        },
        set: function (a) {
            this.h(CategoryYAxis.k9, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryYAxis.prototype, "ku", {
        get: function () {
            return this.kt;
        },
        set: function (a) {
            if (this.ku != a) {
                var b = this.kt;
                this.kt = a;
                this.gu("ActualMinorInterval", b, this.ku);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryYAxis.prototype, "k1", {
        get: function () {
            return this.kz;
        },
        set: function (a) {
            this.kz = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryYAxis.prototype, "k0", {
        get: function () {
            return this.ky;
        },
        set: function (a) {
            this.ky = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryYAxis.prototype.dt = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.kv(a, NumericScaler.ac, b.c);
            c = (c - b.d.top) / b.d.height;
            c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
            return c;
        }
        return this.kv(a, b.e, b.d);
    };
    CategoryYAxis.prototype.kv = function (a, b, c) {
        var d = this.categoryMode == 0 ? this.jr - 1 : this.jr;
        if (d < 0) {
            d = 0;
        }
        var e = d >= 1 ? (a) / (d) : d == 0 ? 0.5 : NaN;
        if (!this.b9) {
            e = 1 - e;
        }
        return c.top + c.height * (e - b.top) / b.height;
    };
    CategoryYAxis.prototype.dw = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            c = (c * b.d.height) + b.d.top;
            c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
            return c;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    CategoryYAxis.prototype.dx = function (a, b, c) {
        if (!b.c.isEmpty) {
            var d = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            d = (d * b.d.height) + b.d.top;
            d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
            return d;
        }
        return this.getUnscaledValue3(a, b.e, b.d, c);
    };
    CategoryYAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.top + (a - c.top) * b.height / c.height;
        if (!this.b9) {
            e = 1 - e;
        }
        var f = d == 0 ? this.jr - 1 : this.jr;
        if (f < 0) {
            f = 0;
        }
        return e * f;
    };
    CategoryYAxis.prototype.k7 = function (a, b) {
        if (a == NaN || b == NaN || this.i8 == null || this.i8.count == 0) {
            return;
        }
        var c = a / this.i8.count;
        var d = b / this.i8.count;
        this.bf.m4 = new Rect(0, this.bf.m4.x, 1 - d, this.bf.m4.width, d - c);
    };
    CategoryYAxis.prototype.as = function () {
        return new VerticalAxisLabelPanel();
    };
    CategoryYAxis.prototype.dg = function () {
        return this.kw;
    };
    CategoryYAxis.prototype.getCategorySize = function (a, b, c) {
        var d = this.is(b, c);
        return d.height / (this.jr * a.height);
    };
    CategoryYAxis.prototype.jk = function (a, b, c) {
        var d = 0;
        if (!isNaN_(this.jh)) {
            d = MathUtil.b(this.jh, 0, 1);
        }
        var e = 0;
        if (!isNaN_(this.jo)) {
            e = Math.min(this.jo, 1);
        }
        var f = 1 - 0.5 * d;
        var g = this.getCategorySize(a, b, c) * f / (this.ju - (this.ju - 1) * e);
        return g;
    };
    CategoryYAxis.prototype.getGroupCenter = function (a, b, c, d) {
        var e = 0.5;
        if (this.ju > 1) {
            var f = 0;
            if (!isNaN_(this.jh)) {
                f = MathUtil.b(this.jh, 0, 1);
            }
            var g = 0;
            if (!isNaN_(this.jo)) {
                g = Math.min(this.jo, 1);
            }
            var h = 1 - 0.5 * f;
            var i = h / (this.ju - (this.ju - 1) * g);
            var j = (h - i) / (this.ju - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    };
    CategoryYAxis.prototype.k6 = function (a) {
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        b = b.copy();
        var c = this.iu;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = this.ir();
        var f = new ScalerParams(0, d, d, this.b8, e);
        var g = !b.isEmpty && !c.isEmpty && this.i8 != null ? this.i8.indexOf(a) : -1;
        var h = g > -1 ? this.dt(g, f) : NaN;
        if (!isNaN_(h) && this.bf.c0) {
            if (!isNaN_(h)) {
                if (h < b.top + 0.1 * b.height) {
                    h = h + 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
                if (h > b.bottom - 0.1 * b.height) {
                    h = h - 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
            }
            this.bf.km(b, false, true);
        }
    };
    CategoryYAxis.prototype.cm = function () {
        if (this.cf && this.cn) {
            this.a9 = this.a8();
        }
        if (this.i8 == null) {
            return false;
        }
        var a = this.i8.count;
        if (a != this.k0) {
            var b = new AxisRangeChangedEventArgs(0, 1, 1, this.k0, a);
            this.k0 = a;
            this.gv(b);
            return true;
        }
        return false;
    };
    CategoryYAxis.prototype.jb = function (a) {
        if (a == null) {
            return false;
        }
        var b = this.bb();
        if (b == null) {
            return false;
        }
        return b.synchronizeVertically;
    };
    CategoryYAxis.prototype.g1 = function (a) {
        _super.prototype.g1.call(this, a);
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        var c = this.iu;
        var d = this.ip();
        var e = this.io();
        var f = new ScalerParams(0, b, c, this.b8, d);
        var g = this.a2.ax();
        var h = this.a2.a0();
        var i = this.a2.ay();
        var j = this.a2.az();
        var k = this.a2.e();
        var l = this.a2.f();
        var m = this.a2.g();
        this.g8();
        this.gc(g);
        this.gc(h);
        this.gc(i);
        this.gc(j);
        this.cs.clear();
        this.ct.clear();
        this.jf.clear();
        this.a2.as(this, b, c);
        if (b.isEmpty || c.isEmpty) {
            this.bo.count = 0;
            this.bn.count = 0;
            this.bm.count = 0;
        }
        if (this.bo.count == 0 && this.bn.count == 0) {
            this.a2.x();
        }
        if (this.aw != null) {
            this.aw.registerAxis(this);
        }
        if (this.itemsSource == null || this.i8 == null || this.i8.count == 0) {
            this.bo.count = 0;
            this.bn.count = 0;
            this.bm.count = 0;
            this.a2.x();
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            var n = this.dw(e.top, f);
            var o = this.dw(e.bottom, f);
            if (!this.b8) {
                n = Math.ceil(n);
                o = Math.floor(o);
            }
            else {
                n = Math.floor(n);
                o = Math.ceil(o);
            }
            var p = c.left;
            var q = 0;
            if (this.ag != null) {
                var r = typeCast(NumericXAxis.$, this.ag);
                if (r != null) {
                    var s = this.g4(p, q, b, c, d, c.left, c.right);
                    p = s.p0;
                    q = s.p1;
                }
            }
            this.g9(g, p, c, k, true);
            this.a2.an(q);
            var t = Math.min(n, o);
            var u = Math.max(n, o);
            var v = new LinearCategorySnapper(1, t, u, e.height, this.kw, this.categoryMode, this.d6());
            var w = Math.floor((t - 0) / v.g);
            var x = Math.ceil((u - 0) / v.g);
            if (!isNaN_(w) && !isNaN_(x)) {
                var y = truncate(w);
                var z = truncate(x);
                var aa = this.dt(0 + y * v.g, f);
                var ab = Math.abs(this.dt(v.g, f) - this.dt(0, f));
                this.at.bn = this.dt(v.g, f);
                for (var ac = y; ac <= z; ++ac) {
                    var ad = this.dt(0 + (ac + 1) * v.g, f);
                    if (aa <= e.bottom) {
                        if (ac % 2 == 0) {
                            this.gl(h, aa, ad, c);
                        }
                        this.gk(i, aa, c, l, false);
                        this.jf.add(aa);
                    }
                    if (this.categoryMode != 0 && this.ju != 0 && this.ci) {
                        if (this.kx > 0 && this.kx < v.g) {
                            var ae = ab * this.kx;
                            if (!this.b8) {
                                var af = aa;
                                while (af - ae > ad) {
                                    af -= ae;
                                    if (Math.abs(af - ad) < 0.0001) {
                                        break;
                                    }
                                    this.gk(j, af, c, m, false);
                                }
                            }
                            else {
                                var ag = aa;
                                while (ag + ae < ad) {
                                    ag += ae;
                                    if (Math.abs(ag - ad) < 0.0001) {
                                        break;
                                    }
                                    this.gk(j, ag, c, m, false);
                                }
                            }
                            this.ku = this.kx;
                        }
                        else {
                            for (var ah = 0; ah < truncate(v.g); ah++) {
                                for (var ai = 0; ai < this.ju; ai++) {
                                    var aj = this.getGroupCenter(ai, b, c, d);
                                    if (!this.b8) {
                                        aj = -aj;
                                    }
                                    var ak = this.dt(ah + ac * v.g, f) + aj;
                                    this.gk(j, ak, c, m, false);
                                }
                            }
                            this.ku = 0.5;
                        }
                    }
                    var al = aa;
                    if (this.categoryMode != 0) {
                        var am = this.dt(ac * v.g + 1, f);
                        al = (aa + am) / 2;
                    }
                    if (al <= e.bottom && al >= e.top) {
                        var an = 0;
                        if (v.g >= 1) {
                            an = ac * truncate(Math.floor(v.g));
                        }
                        else {
                            if ((ac * v.g) * 2 % 2 == 0) {
                                an = truncate(Math.floor(ac * v.g));
                            }
                            else {
                                an = -1;
                            }
                        }
                        if (this.i8 != null && an < this.i8.count && an >= 0) {
                            var ao = this.i8.item(an);
                            var ap = this.e1(ao);
                            if (!isNaN_(al) && !isInfinity(al) && ap != null) {
                                if ((typeof ap === 'string') && Base.equalsStatic(ap, "")) {
                                }
                                else {
                                    this.cs.add1(ap);
                                    this.ct.add(new LabelPosition(al));
                                }
                            }
                        }
                    }
                    aa = ad;
                }
            }
            this.ks = v.g;
            if ((this.aw == null || this.aw.visibility == 0) && this.ag != null) {
                if (this.aw != null && (this.aw.location == 6 || this.aw.location == 7)) {
                    this.bf.ht();
                }
            }
            this.a2.at(this.cs, this.ct);
            this.kf();
        }
    };
    CategoryYAxis.prototype.get_az = function () {
        return 1;
    };
    Object.defineProperty(CategoryYAxis.prototype, "az", {
        get: function () {
            return this.get_az();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryYAxis.prototype, "isVertical", {
        get: function () {
            return this.ce;
        },
        enumerable: true,
        configurable: true
    });
    CategoryYAxis.prototype.j$c = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    CategoryYAxis.prototype.j$b = function (a, b) {
        return this.dt.apply(this, arguments);
    };
    CategoryYAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gg.apply(this, arguments);
    };
    CategoryYAxis.prototype.j$e = function (a, b, c, d) {
        this.gh.apply(this, arguments);
    };
    CategoryYAxis.prototype.j$f = function (a, b, c, d) {
        this.gi.apply(this, arguments);
    };
    Object.defineProperty(CategoryYAxis.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    CategoryYAxis.$t = markType(CategoryYAxis, 'CategoryYAxis', CategoryAxisBase.$);
    CategoryYAxis.k8 = DependencyProperty.i("Interval", Number_$type, CategoryYAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        a.gu("Interval", b.oldValue, b.newValue);
        a.g0(false);
    }));
    CategoryYAxis.k9 = DependencyProperty.i("MinorInterval", Number_$type, CategoryYAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        (typeCast(CategoryYAxis.$, a)).gu("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryYAxis.$, a)).g0(false);
    }));
    return CategoryYAxis;
}(CategoryAxisBase));
export { CategoryYAxis };
/**
 * @hidden
 */
var CategoryYAxisView = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryYAxisView, _super);
    function CategoryYAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bf = null;
        _this.bf = a;
        return _this;
    }
    CategoryYAxisView.$t = markType(CategoryYAxisView, 'CategoryYAxisView', CategoryAxisBaseView.$);
    return CategoryYAxisView;
}(CategoryAxisBaseView));
export { CategoryYAxisView };
